package golfCourse.communication.services;

import jade.core.Agent;
import jade.core.behaviours.SimpleBehaviour;

public class AllServicesWaiter  extends SimpleBehaviour {

	private ServiceFinder myFinder;
	private int servicesCount = 0;

	public AllServicesWaiter(Agent a, ServiceFinder requiredFinder, int servicesCount) {
		super(a);
		myFinder = requiredFinder;
		this.servicesCount = servicesCount;
	}

	private boolean finished = false;

	public void action() {
		if(myFinder.getAllNames().size() >= servicesCount)
		{
			finished = true;
		} else {
			block();
		}
	}

	public boolean done() {
		return finished;
	}

}
