

package golfCourse.ontologies.jastor.golfCourse;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
import com.hp.hpl.jena.rdf.listeners.StatementListener;
import com.hp.hpl.jena.vocabulary.RDF;
import com.ibm.adtech.jastor.*;


/**
 * Implementation of {@link golfCourse.ontologies.jastor.golfCourse.GolfCourse}
 * Use the golfCourse.ontologies.jastor.golfCourse.GolfCourseFactory to create instances of this class.
 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourse#GolfCourse)</p>
 * <br>
 */
public class GolfCourseImpl extends com.ibm.adtech.jastor.ThingImpl implements golfCourse.ontologies.jastor.golfCourse.GolfCourse {
	

	private static com.hp.hpl.jena.rdf.model.Property grassTypeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#grassType");
	private java.lang.String grassType;
	private static com.hp.hpl.jena.rdf.model.Property contactInfoProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#contactInfo");
	private com.ibm.adtech.jastor.Thing contactInfo;
	private static com.hp.hpl.jena.rdf.model.Property nameProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#name");
	private java.lang.String name;
	private static com.hp.hpl.jena.rdf.model.Property permCartProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#permCart");
	private java.lang.Boolean permCart;
	private static com.hp.hpl.jena.rdf.model.Property feeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#fee");
	private java.util.ArrayList fee;
	private static com.hp.hpl.jena.rdf.model.Property addressProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#address");
	private com.ibm.adtech.jastor.Thing address;
	private static com.hp.hpl.jena.rdf.model.Property yardageProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#yardage");
	private java.lang.Float yardage;
	private static com.hp.hpl.jena.rdf.model.Property singlesConfirmedProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#singlesConfirmed");
	private java.lang.Boolean singlesConfirmed;
	private static com.hp.hpl.jena.rdf.model.Property availCaddyProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#availCaddy");
	private java.lang.Boolean availCaddy;
	private static com.hp.hpl.jena.rdf.model.Property homePageProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#homePage");
	private java.lang.String homePage;
	private static com.hp.hpl.jena.rdf.model.Property discountsProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#discounts");
	private java.util.ArrayList discounts;
	private static com.hp.hpl.jena.rdf.model.Property architectProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#architect");
	private java.util.ArrayList architect;
	private static com.hp.hpl.jena.rdf.model.Property acceptedMeanOfPaymentProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#acceptedMeanOfPayment");
	private java.util.ArrayList acceptedMeanOfPayment;
	private static com.hp.hpl.jena.rdf.model.Property slopeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#slope");
	private java.math.BigInteger slope;
	private static com.hp.hpl.jena.rdf.model.Property idProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#id");
	private java.lang.String id;
	private static com.hp.hpl.jena.rdf.model.Property metalSpikesProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#metalSpikes");
	private java.lang.Boolean metalSpikes;
	private static com.hp.hpl.jena.rdf.model.Property reservationProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourse#reservation");
	private java.util.ArrayList reservation;

	GolfCourseImpl(Resource resource, Model model) throws JastorException {
		super(resource, model);
		setupModelListener();
	}     
    	
	static GolfCourseImpl getGolfCourse(Resource resource, Model model) throws JastorException {
		if (!resource.hasProperty(RDF.type,GolfCourse.TYPE))
			throw new JastorException("Resource " + resource + " not of type " + GolfCourse.TYPE);
		return new GolfCourseImpl(resource, model);
	}
	    
	static GolfCourseImpl createGolfCourse(Resource resource, Model model) throws JastorException {
		GolfCourseImpl impl = new GolfCourseImpl(resource, model);
		
		if (!impl._model.contains(new com.hp.hpl.jena.rdf.model.impl.StatementImpl(impl._resource, RDF.type, GolfCourse.TYPE)))
			impl._model.add(impl._resource, RDF.type, GolfCourse.TYPE);
		impl.addSuperTypes();
		impl.addHasValueValues();
		return impl;
	}
	
	void addSuperTypes() {
	}
   
	void addHasValueValues() {
	}
    
    private void setupModelListener() {
    	listeners = new java.util.ArrayList();
    	golfCourse.ontologies.jastor.golfCourse.GolfCourseFactory.registerThing(this);
    }

	public java.util.List listStatements() {
		java.util.List list = new java.util.ArrayList();
		StmtIterator it = null;
		it = _resource.listProperties(grassTypeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(contactInfoProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(nameProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(permCartProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(feeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(addressProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(yardageProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(singlesConfirmedProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(availCaddyProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(homePageProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(discountsProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(architectProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(acceptedMeanOfPaymentProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(slopeProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(idProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(metalSpikesProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _resource.listProperties(reservationProperty);
		while (it.hasNext()) {
			list.add(it.next());
		}
		it = _model.listStatements(_resource,RDF.type, golfCourse.ontologies.jastor.golfCourse.GolfCourse.TYPE);
		while (it.hasNext()) {
			list.add(it.next());
		}
		return list;
	}
	
	public void clearCache() {
		grassType = null;
		contactInfo = null;
		name = null;
		permCart = null;
		fee = null;
		address = null;
		yardage = null;
		singlesConfirmed = null;
		availCaddy = null;
		homePage = null;
		discounts = null;
		architect = null;
		acceptedMeanOfPayment = null;
		slope = null;
		id = null;
		metalSpikes = null;
		reservation = null;
	}

	public java.lang.String getGrassType() throws JastorException {
		if (grassType != null)
			return grassType;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, grassTypeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": grassType getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal grassType in GolfCourse is not of type java.lang.String", literal);
		grassType = (java.lang.String)obj;
		return grassType;
	}
	
	public void setGrassType(java.lang.String grassType) throws JastorException {
		if (_resource.hasProperty(grassTypeProperty)) {
			_resource.removeAll(grassTypeProperty);
		}
		this.grassType = grassType;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (grassType != null) {
			_resource.addProperty(grassTypeProperty, _model.createTypedLiteral(grassType));
		}	
	}


	public com.ibm.adtech.jastor.Thing getContactInfo() throws JastorException {
		if (contactInfo != null)
			return contactInfo;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, contactInfoProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": contactInfo getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		contactInfo = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		return contactInfo;
	}

	public void setContactInfo(com.ibm.adtech.jastor.Thing contactInfo) throws JastorException {
		if (_resource.hasProperty(contactInfoProperty)) {
			_resource.removeAll(contactInfoProperty);
		}
		this.contactInfo = contactInfo;
		if (contactInfo != null) {
			_resource.addProperty(contactInfoProperty, contactInfo.resource());
		}			
	}
		
	public com.ibm.adtech.jastor.Thing setContactInfo() throws JastorException {
		if (_resource.hasProperty(contactInfoProperty)) {
			_resource.removeAll(contactInfoProperty);
		}
		com.ibm.adtech.jastor.Thing contactInfo = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		this.contactInfo = contactInfo;
		_resource.addProperty(contactInfoProperty, contactInfo.resource());
		return contactInfo;
	}
	
	public com.ibm.adtech.jastor.Thing setContactInfo(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (_resource.hasProperty(contactInfoProperty)) {
			_resource.removeAll(contactInfoProperty);
		}
		com.ibm.adtech.jastor.Thing contactInfo = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		this.contactInfo = contactInfo;
		_resource.addProperty(contactInfoProperty, contactInfo.resource());
		return contactInfo;
	}
	
	public java.lang.String getName() throws JastorException {
		if (name != null)
			return name;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, nameProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": name getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal name in GolfCourse is not of type java.lang.String", literal);
		name = (java.lang.String)obj;
		return name;
	}
	
	public void setName(java.lang.String name) throws JastorException {
		if (_resource.hasProperty(nameProperty)) {
			_resource.removeAll(nameProperty);
		}
		this.name = name;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (name != null) {
			_resource.addProperty(nameProperty, _model.createTypedLiteral(name));
		}	
	}

	public java.lang.Boolean getPermCart() throws JastorException {
		if (permCart != null)
			return permCart;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, permCartProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": permCart getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Boolean))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal permCart in GolfCourse is not of type java.lang.Boolean", literal);
		permCart = (java.lang.Boolean)obj;
		return permCart;
	}
	
	public void setPermCart(java.lang.Boolean permCart) throws JastorException {
		if (_resource.hasProperty(permCartProperty)) {
			_resource.removeAll(permCartProperty);
		}
		this.permCart = permCart;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (permCart != null) {
			_resource.addProperty(permCartProperty, _model.createTypedLiteral(permCart));
		}	
	}


	private void initFee() throws JastorException {
		this.fee = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, feeProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/GolfCourse#fee properties in GolfCourse model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing fee = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.fee.add(fee);
			}
		}
	}

	public java.util.Iterator getFee() throws JastorException {
		if (fee == null)
			initFee();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(fee,_resource,feeProperty,true);
	}

	public void addFee(com.ibm.adtech.jastor.Thing fee) throws JastorException {
		if (this.fee == null)
			initFee();
		if (this.fee.contains(fee)) {
			this.fee.remove(fee);
			this.fee.add(fee);
			return;
		}
		this.fee.add(fee);
		_resource.addProperty(feeProperty,fee.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addFee() throws JastorException {
		com.ibm.adtech.jastor.Thing fee = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.fee == null)
			initFee();
		this.fee.add(fee);
		_resource.addProperty(feeProperty,fee.resource());
		return fee;
	}
	
	public com.ibm.adtech.jastor.Thing addFee(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing fee = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.fee == null)
			initFee();
		if (this.fee.contains(fee))
			return fee;
		this.fee.add(fee);
		_resource.addProperty(feeProperty,fee.resource());
		return fee;
	}
	
	public void removeFee(com.ibm.adtech.jastor.Thing fee) throws JastorException {
		if (this.fee == null)
			initFee();
		if (!this.fee.contains(fee))
			return;
		if (!_model.contains(_resource, feeProperty, fee.resource()))
			return;
		this.fee.remove(fee);
		_model.remove(_model.listStatements(_resource, feeProperty, fee.resource()));
	}
		 

	public com.ibm.adtech.jastor.Thing getAddress() throws JastorException {
		if (address != null)
			return address;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, addressProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
			throw new JastorInvalidRDFNodeException(uri() + ": address getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Resource", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
		address = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		return address;
	}

	public void setAddress(com.ibm.adtech.jastor.Thing address) throws JastorException {
		if (_resource.hasProperty(addressProperty)) {
			_resource.removeAll(addressProperty);
		}
		this.address = address;
		if (address != null) {
			_resource.addProperty(addressProperty, address.resource());
		}			
	}
		
	public com.ibm.adtech.jastor.Thing setAddress() throws JastorException {
		if (_resource.hasProperty(addressProperty)) {
			_resource.removeAll(addressProperty);
		}
		com.ibm.adtech.jastor.Thing address = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		this.address = address;
		_resource.addProperty(addressProperty, address.resource());
		return address;
	}
	
	public com.ibm.adtech.jastor.Thing setAddress(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		if (_resource.hasProperty(addressProperty)) {
			_resource.removeAll(addressProperty);
		}
		com.ibm.adtech.jastor.Thing address = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		this.address = address;
		_resource.addProperty(addressProperty, address.resource());
		return address;
	}
	
	public java.lang.Float getYardage() throws JastorException {
		if (yardage != null)
			return yardage;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, yardageProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": yardage getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Float))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal yardage in GolfCourse is not of type java.lang.Float", literal);
		yardage = (java.lang.Float)obj;
		return yardage;
	}
	
	public void setYardage(java.lang.Float yardage) throws JastorException {
		if (_resource.hasProperty(yardageProperty)) {
			_resource.removeAll(yardageProperty);
		}
		this.yardage = yardage;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (yardage != null) {
			_resource.addProperty(yardageProperty, _model.createTypedLiteral(yardage));
		}	
	}

	public java.lang.Boolean getSinglesConfirmed() throws JastorException {
		if (singlesConfirmed != null)
			return singlesConfirmed;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, singlesConfirmedProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": singlesConfirmed getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Boolean))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal singlesConfirmed in GolfCourse is not of type java.lang.Boolean", literal);
		singlesConfirmed = (java.lang.Boolean)obj;
		return singlesConfirmed;
	}
	
	public void setSinglesConfirmed(java.lang.Boolean singlesConfirmed) throws JastorException {
		if (_resource.hasProperty(singlesConfirmedProperty)) {
			_resource.removeAll(singlesConfirmedProperty);
		}
		this.singlesConfirmed = singlesConfirmed;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (singlesConfirmed != null) {
			_resource.addProperty(singlesConfirmedProperty, _model.createTypedLiteral(singlesConfirmed));
		}	
	}

	public java.lang.Boolean getAvailCaddy() throws JastorException {
		if (availCaddy != null)
			return availCaddy;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, availCaddyProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": availCaddy getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Boolean))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal availCaddy in GolfCourse is not of type java.lang.Boolean", literal);
		availCaddy = (java.lang.Boolean)obj;
		return availCaddy;
	}
	
	public void setAvailCaddy(java.lang.Boolean availCaddy) throws JastorException {
		if (_resource.hasProperty(availCaddyProperty)) {
			_resource.removeAll(availCaddyProperty);
		}
		this.availCaddy = availCaddy;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (availCaddy != null) {
			_resource.addProperty(availCaddyProperty, _model.createTypedLiteral(availCaddy));
		}	
	}

	public java.lang.String getHomePage() throws JastorException {
		if (homePage != null)
			return homePage;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, homePageProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": homePage getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal homePage in GolfCourse is not of type java.lang.String", literal);
		homePage = (java.lang.String)obj;
		return homePage;
	}
	
	public void setHomePage(java.lang.String homePage) throws JastorException {
		if (_resource.hasProperty(homePageProperty)) {
			_resource.removeAll(homePageProperty);
		}
		this.homePage = homePage;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (homePage != null) {
			_resource.addProperty(homePageProperty, _model.createTypedLiteral(homePage));
		}	
	}


	private void initDiscounts() throws JastorException {
		this.discounts = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, discountsProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/GolfCourse#discounts properties in GolfCourse model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing discounts = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.discounts.add(discounts);
			}
		}
	}

	public java.util.Iterator getDiscounts() throws JastorException {
		if (discounts == null)
			initDiscounts();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(discounts,_resource,discountsProperty,true);
	}

	public void addDiscounts(com.ibm.adtech.jastor.Thing discounts) throws JastorException {
		if (this.discounts == null)
			initDiscounts();
		if (this.discounts.contains(discounts)) {
			this.discounts.remove(discounts);
			this.discounts.add(discounts);
			return;
		}
		this.discounts.add(discounts);
		_resource.addProperty(discountsProperty,discounts.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addDiscounts() throws JastorException {
		com.ibm.adtech.jastor.Thing discounts = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.discounts == null)
			initDiscounts();
		this.discounts.add(discounts);
		_resource.addProperty(discountsProperty,discounts.resource());
		return discounts;
	}
	
	public com.ibm.adtech.jastor.Thing addDiscounts(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing discounts = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.discounts == null)
			initDiscounts();
		if (this.discounts.contains(discounts))
			return discounts;
		this.discounts.add(discounts);
		_resource.addProperty(discountsProperty,discounts.resource());
		return discounts;
	}
	
	public void removeDiscounts(com.ibm.adtech.jastor.Thing discounts) throws JastorException {
		if (this.discounts == null)
			initDiscounts();
		if (!this.discounts.contains(discounts))
			return;
		if (!_model.contains(_resource, discountsProperty, discounts.resource()))
			return;
		this.discounts.remove(discounts);
		_model.remove(_model.listStatements(_resource, discountsProperty, discounts.resource()));
	}
		 

	private void initArchitect() throws JastorException {
		architect = new java.util.ArrayList();
		
		StmtIterator it = _model.listStatements(_resource, architectProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/GolfCourse#architect properties in GolfCourse model not a Literal", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
			architect.add(literal.getValue());
		}
	}

	public java.util.Iterator getArchitect() throws JastorException {
		if (architect == null)
			initArchitect();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(architect,_resource,architectProperty,false);
	}

	public void addArchitect(java.lang.String architect) throws JastorException {
		if (this.architect == null)
			initArchitect();
		if (this.architect.contains(architect))
			return;
		if (_model.contains(_resource, architectProperty, _model.createTypedLiteral(architect)))
			return;
		this.architect.add(architect);
		_model.add(_resource, architectProperty, _model.createTypedLiteral(architect));
	}
	
	public void removeArchitect(java.lang.String architect) throws JastorException {
		if (this.architect == null)
			initArchitect();
		if (!this.architect.contains(architect))
			return;
		if (!_model.contains(_resource, architectProperty, _model.createTypedLiteral(architect)))
			return;
		this.architect.remove(architect);
		_model.remove(_model.listStatements(_resource, architectProperty, _model.createTypedLiteral(architect)));
	}


	private void initAcceptedMeanOfPayment() throws JastorException {
		this.acceptedMeanOfPayment = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, acceptedMeanOfPaymentProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/GolfCourse#acceptedMeanOfPayment properties in GolfCourse model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.acceptedMeanOfPayment.add(acceptedMeanOfPayment);
			}
		}
	}

	public java.util.Iterator getAcceptedMeanOfPayment() throws JastorException {
		if (acceptedMeanOfPayment == null)
			initAcceptedMeanOfPayment();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(acceptedMeanOfPayment,_resource,acceptedMeanOfPaymentProperty,true);
	}

	public void addAcceptedMeanOfPayment(com.ibm.adtech.jastor.Thing acceptedMeanOfPayment) throws JastorException {
		if (this.acceptedMeanOfPayment == null)
			initAcceptedMeanOfPayment();
		if (this.acceptedMeanOfPayment.contains(acceptedMeanOfPayment)) {
			this.acceptedMeanOfPayment.remove(acceptedMeanOfPayment);
			this.acceptedMeanOfPayment.add(acceptedMeanOfPayment);
			return;
		}
		this.acceptedMeanOfPayment.add(acceptedMeanOfPayment);
		_resource.addProperty(acceptedMeanOfPaymentProperty,acceptedMeanOfPayment.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addAcceptedMeanOfPayment() throws JastorException {
		com.ibm.adtech.jastor.Thing acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.acceptedMeanOfPayment == null)
			initAcceptedMeanOfPayment();
		this.acceptedMeanOfPayment.add(acceptedMeanOfPayment);
		_resource.addProperty(acceptedMeanOfPaymentProperty,acceptedMeanOfPayment.resource());
		return acceptedMeanOfPayment;
	}
	
	public com.ibm.adtech.jastor.Thing addAcceptedMeanOfPayment(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.acceptedMeanOfPayment == null)
			initAcceptedMeanOfPayment();
		if (this.acceptedMeanOfPayment.contains(acceptedMeanOfPayment))
			return acceptedMeanOfPayment;
		this.acceptedMeanOfPayment.add(acceptedMeanOfPayment);
		_resource.addProperty(acceptedMeanOfPaymentProperty,acceptedMeanOfPayment.resource());
		return acceptedMeanOfPayment;
	}
	
	public void removeAcceptedMeanOfPayment(com.ibm.adtech.jastor.Thing acceptedMeanOfPayment) throws JastorException {
		if (this.acceptedMeanOfPayment == null)
			initAcceptedMeanOfPayment();
		if (!this.acceptedMeanOfPayment.contains(acceptedMeanOfPayment))
			return;
		if (!_model.contains(_resource, acceptedMeanOfPaymentProperty, acceptedMeanOfPayment.resource()))
			return;
		this.acceptedMeanOfPayment.remove(acceptedMeanOfPayment);
		_model.remove(_model.listStatements(_resource, acceptedMeanOfPaymentProperty, acceptedMeanOfPayment.resource()));
	}
		 
	public java.math.BigInteger getSlope() throws JastorException {
		if (slope != null)
			return slope;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, slopeProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": slope getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.math.BigInteger))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal slope in GolfCourse is not of type java.math.BigInteger", literal);
		slope = (java.math.BigInteger)obj;
		return slope;
	}
	
	public void setSlope(java.math.BigInteger slope) throws JastorException {
		if (_resource.hasProperty(slopeProperty)) {
			_resource.removeAll(slopeProperty);
		}
		this.slope = slope;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (slope != null) {
			_resource.addProperty(slopeProperty, _model.createTypedLiteral(slope));
		}	
	}

	public java.lang.String getId() throws JastorException {
		if (id != null)
			return id;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, idProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": id getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.String))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal id in GolfCourse is not of type java.lang.String", literal);
		id = (java.lang.String)obj;
		return id;
	}
	
	public void setId(java.lang.String id) throws JastorException {
		if (_resource.hasProperty(idProperty)) {
			_resource.removeAll(idProperty);
		}
		this.id = id;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (id != null) {
			_resource.addProperty(idProperty, _model.createTypedLiteral(id));
		}	
	}

	public java.lang.Boolean getMetalSpikes() throws JastorException {
		if (metalSpikes != null)
			return metalSpikes;
		com.hp.hpl.jena.rdf.model.Statement stmt = _model.getProperty(_resource, metalSpikesProperty);
		if (stmt == null)
			return null;
		if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
			throw new JastorInvalidRDFNodeException(uri() + ": metalSpikes getProperty() in golfCourse.ontologies.jastor.golfCourse.GolfCourse model not Literal", stmt.getObject());
		com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
		Object obj = literal.getValue();
		if (!(obj instanceof java.lang.Boolean))
			throw new JastorInvalidLiteralException (this.uri() + ": Literal metalSpikes in GolfCourse is not of type java.lang.Boolean", literal);
		metalSpikes = (java.lang.Boolean)obj;
		return metalSpikes;
	}
	
	public void setMetalSpikes(java.lang.Boolean metalSpikes) throws JastorException {
		if (_resource.hasProperty(metalSpikesProperty)) {
			_resource.removeAll(metalSpikesProperty);
		}
		this.metalSpikes = metalSpikes;                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
		if (metalSpikes != null) {
			_resource.addProperty(metalSpikesProperty, _model.createTypedLiteral(metalSpikes));
		}	
	}


	private void initReservation() throws JastorException {
		this.reservation = new java.util.ArrayList();
		StmtIterator it = _model.listStatements(_resource, reservationProperty, (RDFNode)null);
		while(it.hasNext()) {
			com.hp.hpl.jena.rdf.model.Statement stmt = (com.hp.hpl.jena.rdf.model.Statement)it.next();
			if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
				throw new JastorInvalidRDFNodeException (uri() + ": One of the file:///D:/ontologies/domain/Golf/GolfCourse#reservation properties in GolfCourse model not a Resource", stmt.getObject());
			com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
			if (true) { // don't check resource type if the property range is Resource
				com.ibm.adtech.jastor.Thing reservation = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
				this.reservation.add(reservation);
			}
		}
	}

	public java.util.Iterator getReservation() throws JastorException {
		if (reservation == null)
			initReservation();
		return new com.ibm.adtech.jastor.util.CachedPropertyIterator(reservation,_resource,reservationProperty,true);
	}

	public void addReservation(com.ibm.adtech.jastor.Thing reservation) throws JastorException {
		if (this.reservation == null)
			initReservation();
		if (this.reservation.contains(reservation)) {
			this.reservation.remove(reservation);
			this.reservation.add(reservation);
			return;
		}
		this.reservation.add(reservation);
		_resource.addProperty(reservationProperty,reservation.resource());
	}
	
	public com.ibm.adtech.jastor.Thing addReservation() throws JastorException {
		com.ibm.adtech.jastor.Thing reservation = com.ibm.adtech.jastor.ThingFactory.createThing(_model.createResource(),_model);
		if (this.reservation == null)
			initReservation();
		this.reservation.add(reservation);
		_resource.addProperty(reservationProperty,reservation.resource());
		return reservation;
	}
	
	public com.ibm.adtech.jastor.Thing addReservation(com.hp.hpl.jena.rdf.model.Resource resource) throws JastorException {
		com.ibm.adtech.jastor.Thing reservation = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
		if (this.reservation == null)
			initReservation();
		if (this.reservation.contains(reservation))
			return reservation;
		this.reservation.add(reservation);
		_resource.addProperty(reservationProperty,reservation.resource());
		return reservation;
	}
	
	public void removeReservation(com.ibm.adtech.jastor.Thing reservation) throws JastorException {
		if (this.reservation == null)
			initReservation();
		if (!this.reservation.contains(reservation))
			return;
		if (!_model.contains(_resource, reservationProperty, reservation.resource()))
			return;
		this.reservation.remove(reservation);
		_model.remove(_model.listStatements(_resource, reservationProperty, reservation.resource()));
	}
		  


	private java.util.ArrayList listeners;
	
	public void registerListener(ThingListener listener) {
		if (!(listener instanceof GolfCourseListener))
			throw new IllegalArgumentException("ThingListener must be instance of GolfCourseListener"); 
		if (listeners == null)
			setupModelListener();
		if(!this.listeners.contains(listener)){
			this.listeners.add((GolfCourseListener)listener);
		}
	}
	
	public void unregisterListener(ThingListener listener) {
		if (!(listener instanceof GolfCourseListener))
			throw new IllegalArgumentException("ThingListener must be instance of GolfCourseListener"); 
		if (listeners == null)
			return;
		if (this.listeners.contains(listener)){
			listeners.remove(listener);
		}
	}



	// private class ThingModelChangedListener extends StatementListener {
	
		public void addedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(grassTypeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					grassType = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.grassTypeChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(contactInfoProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				contactInfo = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						contactInfo = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.contactInfoChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(nameProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					name = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.nameChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(permCartProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Boolean)
					permCart = (java.lang.Boolean) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.permCartChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(feeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _fee = null;
					try {
						_fee = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (fee == null) {
						try {
							initFee();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!fee.contains(_fee))
						fee.add(_fee);
					if (listeners != null) {
						java.util.ArrayList consumersForFee;
						synchronized (listeners) {
							consumersForFee = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForFee.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.feeAdded(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_fee);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				address = null;
				if (true) { // don't check resource type if the property range is Resource
					try {
						address = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
				}
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.addressChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(yardageProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Float)
					yardage = (java.lang.Float) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.yardageChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(singlesConfirmedProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Boolean)
					singlesConfirmed = (java.lang.Boolean) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.singlesConfirmedChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(availCaddyProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Boolean)
					availCaddy = (java.lang.Boolean) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.availCaddyChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(homePageProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					homePage = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.homePageChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(discountsProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _discounts = null;
					try {
						_discounts = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (discounts == null) {
						try {
							initDiscounts();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!discounts.contains(_discounts))
						discounts.add(_discounts);
					if (listeners != null) {
						java.util.ArrayList consumersForDiscounts;
						synchronized (listeners) {
							consumersForDiscounts = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForDiscounts.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.discountsAdded(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_discounts);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(architectProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String) {
					if (architect == null) {
						try {
							initArchitect();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!architect.contains(obj))
						architect.add(obj);
					java.util.ArrayList consumersForArchitect;
					if (listeners != null) {
						synchronized (listeners) {
							consumersForArchitect = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForArchitect.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.architectAdded(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,(java.lang.String)obj);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(acceptedMeanOfPaymentProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _acceptedMeanOfPayment = null;
					try {
						_acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (acceptedMeanOfPayment == null) {
						try {
							initAcceptedMeanOfPayment();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!acceptedMeanOfPayment.contains(_acceptedMeanOfPayment))
						acceptedMeanOfPayment.add(_acceptedMeanOfPayment);
					if (listeners != null) {
						java.util.ArrayList consumersForAcceptedMeanOfPayment;
						synchronized (listeners) {
							consumersForAcceptedMeanOfPayment = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForAcceptedMeanOfPayment.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.acceptedMeanOfPaymentAdded(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_acceptedMeanOfPayment);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(slopeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.math.BigInteger)
					slope = (java.math.BigInteger) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.slopeChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(idProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.String)
					id = (java.lang.String) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.idChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(metalSpikesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();
				if (obj instanceof java.lang.Boolean)
					metalSpikes = (java.lang.Boolean) obj;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.metalSpikesChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(reservationProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _reservation = null;
					try {
						_reservation = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
					} catch (JastorException e) {
						//e.printStackTrace();
					}
					if (reservation == null) {
						try {
							initReservation();
						} catch (JastorException e) {
							e.printStackTrace();
							return;
						}
					}
					if (!reservation.contains(_reservation))
						reservation.add(_reservation);
					if (listeners != null) {
						java.util.ArrayList consumersForReservation;
						synchronized (listeners) {
							consumersForReservation = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForReservation.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.reservationAdded(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_reservation);
						}
					}
				}
				return;
			}
		}
		
		public void removedStatement(com.hp.hpl.jena.rdf.model.Statement stmt) {
//			if (!stmt.getSubject().equals(_resource))
//				return;
			if (stmt.getPredicate().equals(grassTypeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (grassType != null && grassType.equals(obj))
						grassType = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.grassTypeChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(contactInfoProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (contactInfo != null && contactInfo.resource().equals(resource))
						contactInfo = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.contactInfoChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(nameProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (name != null && name.equals(obj))
						name = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.nameChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(permCartProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Boolean)
					if (permCart != null && permCart.equals(obj))
						permCart = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.permCartChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(feeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _fee = null;
					if (fee != null) {
						boolean found = false;
						for (int i=0;i<fee.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) fee.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_fee = __item;
								break;
							}
						}
						if (found)
							fee.remove(_fee);
						else {
							try {
								_fee = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_fee = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForFee;
						synchronized (listeners) {
							consumersForFee = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForFee.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.feeRemoved(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_fee);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(addressProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
					if (address != null && address.resource().equals(resource))
						address = null;				
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.addressChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(yardageProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Float)
					if (yardage != null && yardage.equals(obj))
						yardage = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.yardageChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(singlesConfirmedProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Boolean)
					if (singlesConfirmed != null && singlesConfirmed.equals(obj))
						singlesConfirmed = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.singlesConfirmedChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(availCaddyProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Boolean)
					if (availCaddy != null && availCaddy.equals(obj))
						availCaddy = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.availCaddyChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(homePageProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (homePage != null && homePage.equals(obj))
						homePage = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.homePageChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(discountsProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _discounts = null;
					if (discounts != null) {
						boolean found = false;
						for (int i=0;i<discounts.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) discounts.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_discounts = __item;
								break;
							}
						}
						if (found)
							discounts.remove(_discounts);
						else {
							try {
								_discounts = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_discounts = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForDiscounts;
						synchronized (listeners) {
							consumersForDiscounts = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForDiscounts.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.discountsRemoved(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_discounts);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(architectProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue();//UPDATED
				if (obj instanceof java.lang.String) {
					if (architect != null) {
						if (architect.contains(obj))
							architect.remove(obj);
					}
					if (listeners != null) {
						java.util.ArrayList consumers;
						synchronized (listeners) {
							consumers = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.architectRemoved(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,(java.lang.String)obj);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(acceptedMeanOfPaymentProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _acceptedMeanOfPayment = null;
					if (acceptedMeanOfPayment != null) {
						boolean found = false;
						for (int i=0;i<acceptedMeanOfPayment.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) acceptedMeanOfPayment.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_acceptedMeanOfPayment = __item;
								break;
							}
						}
						if (found)
							acceptedMeanOfPayment.remove(_acceptedMeanOfPayment);
						else {
							try {
								_acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_acceptedMeanOfPayment = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForAcceptedMeanOfPayment;
						synchronized (listeners) {
							consumersForAcceptedMeanOfPayment = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForAcceptedMeanOfPayment.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.acceptedMeanOfPaymentRemoved(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_acceptedMeanOfPayment);
						}
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(slopeProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.math.BigInteger)
					if (slope != null && slope.equals(obj))
						slope = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.slopeChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(idProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.String)
					if (id != null && id.equals(obj))
						id = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.idChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(metalSpikesProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Literal.class))
					return;
				com.hp.hpl.jena.rdf.model.Literal literal = (com.hp.hpl.jena.rdf.model.Literal) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Literal.class);
				//Object obj = literal.getValue();
				Object obj = literal.getValue(); // UPDATED
				if (obj instanceof java.lang.Boolean)
					if (metalSpikes != null && metalSpikes.equals(obj))
						metalSpikes = null;
				if (listeners != null) {
					java.util.ArrayList consumers;
					synchronized (listeners) {
						consumers = (java.util.ArrayList) listeners.clone();
					}
					for(java.util.Iterator iter=consumers.iterator();iter.hasNext();){
						GolfCourseListener listener=(GolfCourseListener)iter.next();
						listener.metalSpikesChanged(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this);
					}
				}
				return;
			}
			if (stmt.getPredicate().equals(reservationProperty)) {
				if (!stmt.getObject().canAs(com.hp.hpl.jena.rdf.model.Resource.class))
					return;
				com.hp.hpl.jena.rdf.model.Resource resource = (com.hp.hpl.jena.rdf.model.Resource) stmt.getObject().as(com.hp.hpl.jena.rdf.model.Resource.class);
				if (true) { // don't check resource type if the property range is Resource
					com.ibm.adtech.jastor.Thing _reservation = null;
					if (reservation != null) {
						boolean found = false;
						for (int i=0;i<reservation.size();i++) {
							com.ibm.adtech.jastor.Thing __item = (com.ibm.adtech.jastor.Thing) reservation.get(i);
							if (__item.resource().equals(resource)) {
								found = true;
								_reservation = __item;
								break;
							}
						}
						if (found)
							reservation.remove(_reservation);
						else {
							try {
								_reservation = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
							} catch (JastorException e) {
							}
						}
					} else {
						try {
							_reservation = com.ibm.adtech.jastor.ThingFactory.getThing(resource,_model);
						} catch (JastorException e) {
						}
					}
					if (listeners != null) {
						java.util.ArrayList consumersForReservation;
						synchronized (listeners) {
							consumersForReservation = (java.util.ArrayList) listeners.clone();
						}
						for(java.util.Iterator iter=consumersForReservation.iterator();iter.hasNext();){
							GolfCourseListener listener=(GolfCourseListener)iter.next();
							listener.reservationRemoved(golfCourse.ontologies.jastor.golfCourse.GolfCourseImpl.this,_reservation);
						}
					}
				}
				return;
			}
		}

	//}
	


}