

package golfCourse.ontologies.jastor.golfCourseTeeTime;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
*/
import com.hp.hpl.jena.rdf.model.*;
//import com.ibm.adtech.jastor.JastorException;

/**
 * Interface for GolfCourseTeeTime ontology class<br>
 * Use the golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTimeFactory to create instances of this interface.
 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#GolfCourseTeeTime)</p>
 * <br>
 * <br>
 * <br>
 */
public interface GolfCourseTeeTime extends com.ibm.adtech.jastor.Thing {
	
	/**
	 * The rdf:type for this ontology class
     */
	public static final Resource TYPE = ResourceFactory.createResource("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#GolfCourseTeeTime");
	

	/**
	 * The Jena Property for golfCourseID 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#golfCourseID)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property golfCourseIDProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#golfCourseID");


	/**
	 * The Jena Property for numberOfTimes 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfTimes)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property numberOfTimesProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfTimes");


	/**
	 * The Jena Property for currencyCode 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#currencyCode)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property currencyCodeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#currencyCode");


	/**
	 * The Jena Property for amount 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#amount)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property amountProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#amount");


	/**
	 * The Jena Property for numberOfHoles 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfHoles)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property numberOfHolesProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfHoles");


	/**
	 * The Jena Property for numberOfGolfers 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfGolfers)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property numberOfGolfersProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#numberOfGolfers");


	/**
	 * The Jena Property for maxPrice 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#maxPrice)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property maxPriceProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#maxPrice");


	/**
	 * The Jena Property for startDate 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#startDate)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property startDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#startDate");


	/**
	 * The Jena Property for endDate 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#endDate)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property endDateProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#endDate");


	/**
	 * The Jena Property for fee 
	 * <p>(URI: file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#fee)</p>
	 * <br>  
	 */
	public static com.hp.hpl.jena.rdf.model.Property feeProperty = ResourceFactory.createProperty("file:///D:/ontologies/domain/Golf/GolfCourseTeeTime#fee");



	/**
	 * Gets the 'golfCourseID' property value
	 * @return		{@link java.lang.String}
	 * @see			#golfCourseIDProperty
	 */
	public java.lang.String getGolfCourseID() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'golfCourseID' property value
	 * @param		{@link java.lang.String}
	 * @see			#golfCourseIDProperty
	 */
	public void setGolfCourseID(java.lang.String golfCourseID) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'numberOfTimes' property value
	 * @return		{@link java.math.BigInteger}
	 * @see			#numberOfTimesProperty
	 */
	public java.math.BigInteger getNumberOfTimes() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'numberOfTimes' property value
	 * @param		{@link java.math.BigInteger}
	 * @see			#numberOfTimesProperty
	 */
	public void setNumberOfTimes(java.math.BigInteger numberOfTimes) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'currencyCode' property value
	 * @return		{@link java.lang.String}
	 * @see			#currencyCodeProperty
	 */
	public java.lang.String getCurrencyCode() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'currencyCode' property value
	 * @param		{@link java.lang.String}
	 * @see			#currencyCodeProperty
	 */
	public void setCurrencyCode(java.lang.String currencyCode) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'amount' property value
	 * @return		{@link java.lang.Float}
	 * @see			#amountProperty
	 */
	public java.lang.Float getAmount() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'amount' property value
	 * @param		{@link java.lang.Float}
	 * @see			#amountProperty
	 */
	public void setAmount(java.lang.Float amount) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'numberOfHoles' property value
	 * @return		{@link java.math.BigInteger}
	 * @see			#numberOfHolesProperty
	 */
	public java.math.BigInteger getNumberOfHoles() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'numberOfHoles' property value
	 * @param		{@link java.math.BigInteger}
	 * @see			#numberOfHolesProperty
	 */
	public void setNumberOfHoles(java.math.BigInteger numberOfHoles) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'numberOfGolfers' property value
	 * @return		{@link java.math.BigInteger}
	 * @see			#numberOfGolfersProperty
	 */
	public java.math.BigInteger getNumberOfGolfers() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'numberOfGolfers' property value
	 * @param		{@link java.math.BigInteger}
	 * @see			#numberOfGolfersProperty
	 */
	public void setNumberOfGolfers(java.math.BigInteger numberOfGolfers) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'maxPrice' property value
	 * @return		{@link java.lang.Float}
	 * @see			#maxPriceProperty
	 */
	public java.lang.Float getMaxPrice() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'maxPrice' property value
	 * @param		{@link java.lang.Float}
	 * @see			#maxPriceProperty
	 */
	public void setMaxPrice(java.lang.Float maxPrice) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'startDate' property value
	 * @return		{@link java.lang.String}
	 * @see			#startDateProperty
	 */
	public java.lang.String getStartDate() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'startDate' property value
	 * @param		{@link java.lang.String}
	 * @see			#startDateProperty
	 */
	public void setStartDate(java.lang.String startDate) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Gets the 'endDate' property value
	 * @return		{@link java.lang.String}
	 * @see			#endDateProperty
	 */
	public java.lang.String getEndDate() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Sets the 'endDate' property value
	 * @param		{@link java.lang.String}
	 * @see			#endDateProperty
	 */
	public void setEndDate(java.lang.String endDate) throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Get an Iterator the 'fee' property values.  This Iteartor
	 * may be used to remove all such values.
	 * @return		{@link java.util.Iterator} of {@link com.ibm.adtech.jastor.Thing}
	 * @see			#feeProperty
	 */
	public java.util.Iterator getFee() throws com.ibm.adtech.jastor.JastorException;

	/**
	 * Adds a value for the 'fee' property
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to add
	 * @see			#feeProperty
	 */
	public void addFee(com.ibm.adtech.jastor.Thing fee) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds an anonymous value for the 'fee' property
	 * @return		The anoymous {@link com.ibm.adtech.jastor.Thing} created
	 * @see			#feeProperty
	 */
	public com.ibm.adtech.jastor.Thing addFee() throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Adds a value for the 'fee' property.  This
	 * method is equivalent constructing a new instance of {@link com.ibm.adtech.jastor.Thing} with the factory
	 * and calling addFee(com.ibm.adtech.jastor.Thing fee)
	 * The resource argument have rdf:type http://www.w3.org/2000/01/rdf-schema#Resource.  That is, this method
	 * should not be used as a shortcut for creating new objects in the model.
	 * @param		The {@link om.hp.hpl.jena.rdf.model.Resource} to add
	 * @see			#feeProperty
	 */
	public com.ibm.adtech.jastor.Thing addFee(com.hp.hpl.jena.rdf.model.Resource resource) throws com.ibm.adtech.jastor.JastorException;
	
	/**
	 * Removes a value for the 'fee' property.  This method should not
	 * be invoked while iterator through values.  In that case, the remove() method of the Iterator
	 * itself should be used.
	 * @param		The {@link com.ibm.adtech.jastor.Thing} to remove
	 * @see			#feeProperty
	 */
	public void removeFee(com.ibm.adtech.jastor.Thing fee) throws com.ibm.adtech.jastor.JastorException;
		
}