

package golfCourse.ontologies.jastor.golfCourseTeeTime;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
import com.hp.hpl.jena.rdf.model.*;
import com.ibm.adtech.jastor.*;
import java.util.*;
import java.math.*;
*/


/**
 * Implementations of this listener may be registered with instances of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime to 
 * receive notification when properties changed, added or removed.
 * <br>
 */
public interface GolfCourseTeeTimeListener extends com.ibm.adtech.jastor.ThingListener {


	/**
	 * Called when golfCourseID has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void golfCourseIDChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when numberOfTimes has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void numberOfTimesChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when currencyCode has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void currencyCodeChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when amount has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void amountChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when numberOfHoles has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void numberOfHolesChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when numberOfGolfers has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void numberOfGolfersChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when maxPrice has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void maxPriceChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when startDate has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void startDateChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when endDate has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 */
	public void endDateChanged(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source);

	/**
	 * Called when a value of fee has been added
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 * @param newValue the object representing the new value
	 */	
	public void feeAdded(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source, com.ibm.adtech.jastor.Thing newValue);

	/**
	 * Called when a value of fee has been removed
	 * @param source the affected instance of golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime
	 * @param oldValue the object representing the removed value
	 */
	public void feeRemoved(golfCourse.ontologies.jastor.golfCourseTeeTime.GolfCourseTeeTime source, com.ibm.adtech.jastor.Thing oldValue);
		
}