package golfCourse.translations.toOTA;

import golfCourse.exceptions.TranslateException;
import golfCourse.ontologies.jastor.contacts.Contacts;
import golfCourse.translations.castor.Phone;

import java.io.StringWriter;
import java.io.Writer;

import org.exolab.castor.xml.MarshalException;
import org.exolab.castor.xml.ValidationException;

import com.ibm.adtech.jastor.JastorException;

/** 
 * Translate Contacts to ota Phone
 */
public class OTAPhoneTranslator {

	public static Phone translateToOTA(Contacts contacts) throws TranslateException
	{
		Phone phone = new Phone();
		//phone.setAreaCityCode()
		//phone.setCountryAccessCode()
		
		// Refer to code table
		/*phone.setPhoneLocationType()
		 * phone.setPhoneUseType()
		 * phone.setPhoneTechType() */
		try {
		//ContactTechnology contactTech = contacts.getTechnology();
		//if(contactTech.uri().endsWith("Telephone"))
		//{
			phone.setPhoneNumber(contacts.getAddress());
		//}
		//else throw new TranslateException("Not a phone");
		} catch(JastorException e)
		{
			throw new TranslateException("Jastor exception " + e);
		}
		
		try{
			phone.validate();
		} catch(ValidationException e)
		{
			throw new TranslateException("Validation exception " + e);
		}
		//phone.setPIN()
		return phone;
	}
	
	public static String translateToOTAString(Contacts contacts)throws TranslateException
	{
		Phone phone = translateToOTA(contacts);
		
		Writer writer = new StringWriter();
		try {
			phone.marshal(writer);
		}
		catch(MarshalException e)
		{
			throw new TranslateException("Marshal exception " + e);
		}
		catch(ValidationException e2)
		{
			throw new TranslateException("Validation exception " + e2);
		}	
		
		return writer.toString();
	}
}
