package golfCourse.agents.managerAgent.behaviours;

import golfCourse.agents.managerAgent.ManagerAgent;
import golfCourse.agents.managerAgent.customer.behaviours.CloseSystemBehaviour;
import jade.core.Agent;
import jade.core.behaviours.OneShotBehaviour;
import jade.util.Logger;

public class ReceiveSystemErrorBehaviour extends OneShotBehaviour{
	
	private static Logger logger = Logger.getMyLogger(ReceiveSystemErrorBehaviour.class.getName());

	String errorMessage = "";
	ManagerAgent myAgent;
	
	public ReceiveSystemErrorBehaviour(String errorMessage, Agent myAgent)
	{
		this.errorMessage = errorMessage;
		this.myAgent = (ManagerAgent)myAgent;
	}
	
	public void action()
	{
		logger.info("**************************** \n System error: \n" + errorMessage + "****************************" );
		myAgent.addBehaviour(new CloseSystemBehaviour(myAgent));
	}


}
