

package golfCourse.ontologies.jastor.location;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
import com.hp.hpl.jena.rdf.model.*;
import com.ibm.adtech.jastor.*;
import java.util.*;
import java.math.*;
*/


/**
 * Implementations of this listener may be registered with instances of golfCourse.ontologies.jastor.location.AddressRecord to 
 * receive notification when properties changed, added or removed.
 * <br>
 */
public interface AddressRecordListener extends com.ibm.adtech.jastor.ThingListener {


	/**
	 * Called when zip has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void zipChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when fullAddress has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void fullAddressChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when region has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void regionChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when flatNumber has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void flatNumberChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when country has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void countryChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when houseNumber has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void houseNumberChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when street has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void streetChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

	/**
	 * Called when city has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.location.AddressRecord
	 */
	public void cityChanged(golfCourse.ontologies.jastor.location.AddressRecord source);

}