

package golfCourse.ontologies.jastor.price;

/*
import com.hp.hpl.jena.datatypes.xsd.*;
import com.hp.hpl.jena.datatypes.xsd.impl.*;
import com.hp.hpl.jena.rdf.model.*;
import com.ibm.adtech.jastor.*;
import java.util.*;
import java.math.*;
*/


/**
 * Implementations of this listener may be registered with instances of golfCourse.ontologies.jastor.price.Price to 
 * receive notification when properties changed, added or removed.
 * <br>
 */
public interface PriceListener extends com.ibm.adtech.jastor.ThingListener {


	/**
	 * Called when amount has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 */
	public void amountChanged(golfCourse.ontologies.jastor.price.Price source);

	/**
	 * Called when a value of tax has been added
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 * @param newValue the object representing the new value
	 */	
	public void taxAdded(golfCourse.ontologies.jastor.price.Price source, com.ibm.adtech.jastor.Thing newValue);

	/**
	 * Called when a value of tax has been removed
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 * @param oldValue the object representing the removed value
	 */
	public void taxRemoved(golfCourse.ontologies.jastor.price.Price source, com.ibm.adtech.jastor.Thing oldValue);
		
	/**
	 * Called when currencyCode has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 */
	public void currencyCodeChanged(golfCourse.ontologies.jastor.price.Price source);

	/**
	 * Called when percent has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 */
	public void percentChanged(golfCourse.ontologies.jastor.price.Price source);

	/**
	 * Called when taxInclusive has changed
	 * @param source the affected instance of golfCourse.ontologies.jastor.price.Price
	 */
	public void taxInclusiveChanged(golfCourse.ontologies.jastor.price.Price source);

}